#include <stdint.h>
#include <stdlib.h>
#include <stdbool.h>
#include <cell/gcm.h>

#include <sys/cdefs.h>

#define CMD_BUFFER_SIZE (1024 * 64)
#define IO_BUFFER_SIZE (1024 * 1024)
#define COLOR_BUFFER_NUM 2
#define SHADER(x) extern uint32_t _binary_##x##_start; static unsigned char *shader_##x##_ptr = (unsigned char *)&_binary_##x##_start; CGprogram shader_##x; static void *shader_##x##_ucode; static uint32_t shader_##x##_offset

#define FONT_HEIGHT 9
#define FONT_WIDTH 8
#define FONT_SCALE 1

typedef struct {
	void *address;
	uint32_t offset;
	uint32_t pitch;
	uint32_t width;
	uint32_t height;
} color_buf_t;

typedef struct {
	uint8_t a;
	uint8_t r;
	uint8_t g;
	uint8_t b;
} color4_t;
extern color4_t *display;
extern color4_t *display_back;
extern color_buf_t color_buf[COLOR_BUFFER_NUM];

extern void cellGcmUtilWaitFlip();

extern void cellGcmUtilFlip();

extern void cellGcmUtilInitShader();

extern void cellGcmUtilSetDrawEnv(void);

extern void cellGcmUtilSetRenderColor();

extern void cellGcmUtilRender(bool sync);

extern void cellGcmUtilSetRenderTarget(const uint32_t Index);

extern void cellGcmUtilClearSurface();

extern void cellGcmUtilInitDisplay();
extern void cellGcmUtilInitDisplay2();
