/* shamelessly based on an example */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "cellpadutil.h"

#define dprintf(x)
#define MAX_PADS 7

static CellPadData PadData[MAX_PADS];
#ifdef PS3_SDK_3_41
	static CellPadInfo2 PadInfo;
#else
	static CellPadInfo PadInfo;
#endif

int32_t cellPadUtilPadInit()
{
	// call cellpadInit()
	return cellPadInit( MAX_PADS );
}

int32_t cellPadUtilPadDeinit()
{
	// call cellPadEnd()
	return cellPadEnd();
}

//int32_t cellPadUtilUpdate(uint8_t **status)
bool cellPadUtilUpdate(uint8_t id)
{
	int32_t ret = 0;

	// get pad info
#ifdef PS3_SDK_3_41
	ret = cellPadGetInfo2 ( &PadInfo);
#else
	ret = cellPadGetInfo ( &PadInfo);
#endif
	if(ret != CELL_PAD_OK ) return false;

#ifdef PS3_SDK_3_41
	ret = PadInfo.port_status[id];
#else
	ret = PadInfo.status[id];
#endif
	if (ret == CELL_PAD_STATUS_CONNECTED) {
		// get pad data
		ret = cellPadGetData( id, &PadData[id] );
		if( ret != CELL_PAD_OK ) return false;
		if (PadData[id].len == 0)
			return false;
		return true;
	}
	return true;
}

uint32_t cellPadUtilNumberPadsConnected()
{
#ifdef PS3_SDK_3_41
	cellPadGetInfo2 ( &PadInfo);
#else
	cellPadGetInfo ( &PadInfo);
#endif
	return PadInfo.now_connect;
}

// is a button pressed? if yes, return true,  if not, return false
bool cellPadUtilButtonPressed(uint8_t pad, int button)
{
 	return (cellPadUtilGetData(&PadData[pad], button) & GET_TARGET_BIT(button)) != 0;
}

// is a button released? if yes, return true, if not, return false
bool cellPadUtilButtonReleased(uint8_t pad, int button)
{
	return (cellPadUtilGetData(&PadData[pad], button) & GET_TARGET_BIT(button)) == 0;
}

CellPadUtilAxis cellPadUtilAxisGetValue(uint8_t pad, int axis)
{
	CellPadUtilAxis ret;

	ret.x = cellPadUtilGetData( &PadData[pad], axis);
	axis = ((GET_SHIFT_BIT( axis ) + 0x1) << 8) | 0xFF;
	ret.y = cellPadUtilGetData( &PadData[pad], axis);
	return ret;
}


bool cellPadUtilAnalogPressedLeft(uint8_t pad, int axis)
{
	//CellPadUtilAxis ret = cellPadUtilAxisGetValue(pad,axis);
	//bool ispressedleft = (ret.x <= 110);
	return (cellPadUtilGetXAxisValue(pad,axis) <= 55);
}


bool cellPadUtilAnalogPressedRight(uint8_t pad, int axis)
{
	//CellPadUtilAxis ret = cellPadUtilAxisGetValue(pad,axis);
	//bool ispressedright = (150 <= ret.x);
	return (210 <= cellPadUtilGetXAxisValue(pad,axis));
}

bool cellPadUtilAnalogPressedDown(uint8_t pad, int axis)
{
	//CellPadUtilAxis ret = cellPadUtilAxisGetValue(pad,axis);
	//bool ispresseddown = (150 <= ret.y);
	return (210 <= cellPadUtilGetYAxisValue(pad,axis));
}

bool cellPadUtilAnalogPressedUp(uint8_t pad, int axis)
{
	//CellPadUtilAxis ret = cellPadUtilAxisGetValue(pad,axis);
	return (cellPadUtilGetYAxisValue(pad,axis) <= 55);
}

uint8_t cellPadUtilGetXAxisValue(uint8_t pad, int axis)
{
	CellPadUtilAxis ret = cellPadUtilAxisGetValue(pad,axis);
	return ret.x;
}

uint8_t cellPadUtilGetYAxisValue(uint8_t pad, int axis)
{
	CellPadUtilAxis ret = cellPadUtilAxisGetValue(pad,axis);
	return ret.y;
}

// return CellPadData
const CellPadData* cellPadUtilGetPadData(uint8_t pad)
{
	if(pad >= cellPadUtilNumberPadsConnected()) return 0;
	return &PadData[pad];
}


