/* shamelessly based on an example */

#ifndef __PAD_UTILS_H__
#define __PAD_UTILS_H__

#include <stdint.h>
#include <stdlib.h>
#include <stdbool.h>
#include <cell/pad.h>

#include <sys/cdefs.h>

CDECL_BEGIN

#define CTRL_SELECT		( 0x0200 	|	0x01 )
#define CTRL_L3		( 0x0200	|	0x02 )
#define CTRL_R3		( 0x0200	|	0x04 )
#define CTRL_START		( 0x0200	|	0x08 )
#define CTRL_UP		( 0x0200	|	0x10 )
#define CTRL_RIGHT		( 0x0200	|	0x20 )
#define CTRL_DOWN		( 0x0200	|	0x40 )
#define CTRL_LEFT		( 0x0200	|	0x80 )

#define CTRL_L2		( 0x0300	|	0x01 )
#define CTRL_R2		( 0x0300	|	0x02 )
#define CTRL_L1		( 0x0300	|	0x04 )
#define CTRL_R1		( 0x0300	|	0x08 )
#define CTRL_TRIANGLE	( 0x0300	|	0x10 )
#define CTRL_CIRCLE		( 0x0300	|	0x20 )
#define CTRL_CROSS		( 0x0300	|	0x40 )
#define CTRL_SQUARE		( 0x0300	|	0x80 )

#define CTRL_RSTICK		( 0x0400	|	0xFF )
#define CTRL_LSTICK		( 0x0600	|	0xFF )

#define GET_SHIFT_BIT( x ) (( x >> 8 ) & 0xFF )
#define GET_TARGET_BIT( x ) ( x & 0xFF )

typedef struct {
	uint8_t x;
	uint8_t y;
} CellPadUtilAxis;

extern int32_t cellPadUtilPadInit( void );
extern int32_t cellPadUtilPadDeinit( void );

// status is return value.
// CellPadInfo.status[CELL_MAX_PADS]
//extern int32_t cellPadUtilUpdate (uint8_t **status );
extern bool cellPadUtilUpdate(uint8_t i);
extern uint32_t cellPadUtilNumberPadsConnected();

static inline int8_t cellPadUtilGetData( CellPadData* pData, int button)
{
	return pData->button[GET_SHIFT_BIT(button)];
}

// buttons
extern bool cellPadUtilButtonPressed(uint8_t pad, int button);
extern bool cellPadUtilButtonReleased(uint8_t pad, int button);

// axis
extern CellPadUtilAxis cellPadUtilAxisGetValue(uint8_t pad, int axis);
extern uint8_t cellPadUtilGetXAxisValue(uint8_t pad, int axis);
extern uint8_t cellPadUtilGetYAxisValue(uint8_t pad, int axis);
extern bool cellPadUtilAnalogPressedLeft(uint8_t pad, int axis);
extern bool cellPadUtilAnalogPressedRight(uint8_t pad, int axis);
extern bool cellPadUtilAnalogPressedDown(uint8_t pad, int axis);
extern bool cellPadUtilAnalogPressedUp(uint8_t pad, int axis);

// pad data
extern const CellPadData* cellPadUtilGetPadData(uint8_t pad);

CDECL_END

#endif /* __PAD_UTILS_H__ */
